/*
 * Created on 6.2.2006
 *
 */
package cz.muni.fi.pb138.demo.xinclude;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.OutputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;

import com.elharo.xml.xinclude.DOMXIncluder;
import com.elharo.xml.xinclude.XIncludeException;

public class Demo {

    public static Document readAsDOMWithXInclude(File f) {

        // get a DocumentBuilderFactory instance
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();

        // set the options
        //        factory.setValidating(true);
        factory.setNamespaceAware(true);
        try {
            // get a  DocumentBuilder
            DocumentBuilder builder = factory.newDocumentBuilder();
            
            // parse the file into a new document
            Document document = builder.parse(f);
            
            // process the XML Inclusions hrefs
            document = DOMXIncluder.merge(document, "file:.");
            
            return document;

        } catch (SAXException sxe) {
            // Error generated during parsing
            Exception x = sxe;
            if (sxe.getException() != null)
                x = sxe.getException();
            x.printStackTrace();

        } catch (XIncludeException xie) {
            // show the XInclude Exception
            xie.printStackTrace();

        } catch (ParserConfigurationException pce) {
            // Parser with specified options can't be built
            pce.printStackTrace();

        } catch (IOException ioe) {
            // I/O error
            ioe.printStackTrace();
            
        } catch (NullPointerException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return null;
    }

    public static void dumpDOM(Document document, OutputStream os) throws TransformerException {
        
        TransformerFactory tf = TransformerFactory.newInstance();
        
        Transformer transformer = tf.newTransformer();
        
        DOMSource ds = new DOMSource(document);
        
        StreamResult sr = new StreamResult(os);
        
        transformer.transform(ds, sr);
    }

    /**
     * @param args
     * @throws TransformerException 
     * @throws FileNotFoundException 
     */
    public static void main(String[] args) throws TransformerException, FileNotFoundException {

        System.out.println("--- read XML doc with xinclude href ---");
        
        Document document2 = readAsDOMWithXInclude(new File("demo-xinclude.xml"));

        System.out.println("--- print it ---");
        dumpDOM(document2, System.out);
        
    }

}
